/*
    Copyright 2004,2005,2006 Luigi Auriemma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    http://www.gnu.org/licenses/gpl.txt

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define VER     "0.1"
#ifndef u_char
    #define u_char  unsigned char
#endif
#ifndef u_short
    #define u_short unsigned short
#endif



void ftpctrl_pwd(u_char *pwd);



int main(int argc, char *argv[]) {
    setbuf(stdout, NULL);

    fputs("\n"
        "FTP Control password decoder "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    if(argc < 2) {
        printf("\nUsage: %s <password*>\n"
            "\n"
            "* passwords are stored in the files .prf in the folder Profiles\n"
            "\n", argv[0]);
        exit(1);
    }

    ftpctrl_pwd(argv[1]);
    printf("\nDecoded password:   %s\n\n", argv[1]);

    return(0);
}



void ftpctrl_pwd(u_char *pwd) {
    int     len,
            tmp;
    u_short si = 0x2396;
    u_char  *ptr;

    ptr = pwd;
    len = strlen(pwd) >> 1;
    while(len--) {
        sscanf(pwd, "%02X", &tmp);
        *ptr++ = tmp ^ (si >> 8);
        si = ((si + tmp) * 0xce6d) + 0x58bf;
        pwd++;
        pwd++;
    }
    *ptr = 0;
}


